// I2CBusMaster.cpp : Implementation of CComi2cApp and DLL registration.

#include "stdafx.h"
#include "comi2c.h"
#include "I2CBusMaster.h"


/////////////////////////////////////////////////////////////////////////////
//

STDMETHODIMP CI2CBusMaster::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_II2CBusMaster,
	};

	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CI2CBusMaster::Open(BSTR lpszComDevice)
{
	USES_CONVERSION;

	if (!I2COpen(W2T(lpszComDevice), &m_driverContext))
		return E_ACCESSDENIED;
	else
		return S_OK;
}

STDMETHODIMP CI2CBusMaster::Close()
{
	if (!I2CClose(&m_driverContext))
		return E_UNEXPECTED; // if Open has succeeded close should work.
	else
		return S_OK;
}

STDMETHODIMP CI2CBusMaster::TransmitData(VARIANT_BOOL bSendStop, unsigned char Address, short BytesToSend, unsigned char *DataPtr, VARIANT_BOOL *pRetVal)
{
	*pRetVal = I2CTransmitData(&m_driverContext, bSendStop, Address, BytesToSend, DataPtr)?0xffff:0;
	return S_OK;
}

STDMETHODIMP CI2CBusMaster::ReceiveData(unsigned char Address, short BytesToReceive, unsigned char *DataPtr, VARIANT_BOOL *pRetVal)
{
	*pRetVal = I2CReceiveData(&m_driverContext, Address, BytesToReceive, DataPtr)?0xffff:0;
	return S_OK;
}
